#include <alpm.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

#include "dependency.h"

betaur_dependency_t* betaur_dependency_create(size_t depstring_len, char* depstring) {
	betaur_dependency_t* bdep = (betaur_dependency_t *) malloc(sizeof(betaur_dependency_t));
	char* pos;
	bdep->depstring = depstring;
	bdep->name = depstring;
	bdep->mod = BETAUR_ANY;
	assert(bdep != NULL);
	if (pos = strstr(depstring, "<=")) {

		bdep->mod = BETAUR_LE;
		bdep->name_len = (size_t) (pos - depstring);
		bdep->version = pos + 2;
		bdep->version_len = (size_t) depstring_len - bdep->name_len - 2;
	} else if (pos = strstr(depstring, ">=")) {
		bdep->mod = BETAUR_GE;
		bdep->name_len = (size_t) (pos - depstring);
		bdep->version = pos + 2;
		bdep->version_len = (size_t) depstring_len - bdep->name_len - 2;
	} else {
		for (pos = depstring; pos < (depstring + depstring_len); pos++) {
			switch  (*pos) {
				case '<':
					bdep->mod = BETAUR_LT;
					break;
				case '>':
					bdep->mod = BETAUR_GT;
					break;
				case '=':
					bdep->mod = BETAUR_EQ;
					break;
			}
		}
		if (bdep->mod != BETAUR_ANY) {
			bdep->name_len = (size_t) (pos - depstring);
			bdep->version = pos + 1;
			bdep->version_len = (size_t) depstring_len - bdep->name_len - 1;
		} else {
			bdep->name = depstring;
		}
	}

	return bdep;
}


bool betaur_satisfied_by_version(betaur_dependency_t* bdep, const char* version) {
	// FIXME we may need to make a copy here
	// This will most probably crash when reading input from files
	int vercmp = alpm_pkg_vercmp(version, bdep->version);
	// TODO can't we just return vercmp??? hmmm...
	switch(bdep->mod) {
		case BETAUR_EQ:
			return vercmp == 0;
		case BETAUR_GE:
			return vercmp >= 0;
		case BETAUR_GT:
			return vercmp > 0;
		case BETAUR_LE:
			return vercmp <= 0;
		case BETAUR_LT:
			return vercmp < 0;
		default:
			break;
	}
	return false;
}

bool betaur_satisfied_by(betaur_package_t bpack) {
	return false;
}
